; #########################################################################

    .386
    .model flat, stdcall  ; 32 bit memory model
    option casemap : none ; case sensitive

    include     \masm32\include\ole32.inc
    includelib  \masm32\lib\ole32.lib

; #########################################################################

    .data

    Alloc_pIMalloc dd 0

    .code

; #########################################################################

IMalloc proc public
;{
    ;--------------------------------------------------------------------------
    ; IMalloc returns the interface pointer to the memory allocator.
    ; This interface pointer cannot be used from a remote process -
    ; each process must have its own allocator.
    ;
    ; If an error occured while fetching the interface pointer,
    ; IMalloc returns NULL.
    ;
    ; EXAMPLE:
    ; invoke IMalloc ; returns interface pointer in eax
    ;
    ; Uses: eax, ecx, edx
    ;--------------------------------------------------------------------------

    lea     ecx, [ Alloc_pIMalloc ]
    mov     eax, [ ecx ]

    .IF eax
    ;{
        ret
    ;}
    .ENDIF

@@: invoke  CoGetMalloc, 1, ecx
    or      eax, eax
    jz      IMalloc
    ;{
        xor eax, eax
        ret
    ;}
;}
IMalloc endp

end